SET NAMES WIN1251;
SET CLIENTLIB 'fbclient.dll';
connect 'd:\Smarket.fdb' user 'sysdba' password '3';

ALTER TABLE TMP_PLANOGRAM_CHANGE DROP CONSTRAINT PK_TMP_PLANOGRAM_CHANGE;
alter table TMP_PLANOGRAM_CHANGE add constraint PK_TMP_PLANOGRAM_CHANGE primary key (PLACE_ID,EQUIPMENT_ID,SHELF_ID,ARTICUL,NUM) using index PK_TMP_PLANOGRAM_CHANGE;

set term ^ ;

create or alter procedure METRO_MAKE_DOCS (
    SHOPINDEX integer,
    CLIENT integer,
    PLACE integer,
    DOCTYPE integer,
    OPERATION integer,
    EXT_DOCTYPE integer,
    NEED_ACCEPT integer)
returns (
    DOCHEAD integer)
AS
declare variable v_id integer;
declare variable v_invoice_date date;
declare variable v_invoice_no varchar(20);
declare variable v_dochead integer;
declare variable v_docindex varchar(10);
declare variable v_pack varchar(20);
declare variable v_quantity double precision;
declare variable v_summa double precision;
declare variable v_pricerub double precision;
declare variable v_nds double precision;
declare variable v_taxhead integer;
declare variable v_user integer;
declare variable v_articul varchar(30);
declare variable v_country integer;
declare variable v_country_code varchar(5);
declare variable v_custom varchar(255);
begin
  select id from CUR_USER into :v_user;

  for select t.id, t.invoice_date, t.invoice_no
      from TMP_METRO_HEAD t
      left join METRO_DOCS d on d.invoice_date = t.invoice_date and d.invoice_no = t.invoice_no
      where d.dochead is null and t.need_import = 1
      into :v_id, :v_invoice_date, :v_invoice_no
  do begin
    v_dochead=null;
    --    
    for select sm_articul, sm_pack, quantity_in_pack*quantity, summa, nds,
               case when nds_proc=0 then 5 when nds_proc=10 then 1 else 7 end,
               cdn, cdn_country
        from TMP_METRO_SPEC
        where id=:v_id
        into :v_articul, :v_pack, :v_quantity, :v_summa, :v_nds, :v_taxhead,
             :v_custom, :v_country_code
    do begin
      if (v_dochead is null) then begin
        --     ,  
        v_dochead = gen_id(dochead_gen,1);
        select docindex from GET_NEW_DOCINDEX(:shopindex, :doctype) into :v_docindex;
        insert into DOCHEAD (id_dochead, shopindex, docindex, doc_date, doctype, operation,
                             client_index, client2_index, ext_docindex, ext_doc_date, ext_doctype, doc_state, manager)
            values (:v_dochead, :shopindex, :v_docindex, extractdate('now'), :doctype, :operation,
                    :client, :place, :v_invoice_no, :v_invoice_date, :ext_doctype, -1, :v_user);
        update DOCHEAD set moddate = moddate + 0.00001 where id_dochead = :v_dochead;
        insert into METRO_DOCS (invoice_date, invoice_no, dochead) values (:v_invoice_date, :v_invoice_no, :v_dochead);
        if (dochead is null) then dochead=v_dochead; --     
      end
      --     
      if (v_quantity>1e-8) then v_pricerub=v_summa/v_quantity; else v_pricerub=0;
      execute procedure SPEC_ADD(:v_dochead,:v_articul,:v_pack,0,:v_quantity,:v_pricerub,0);
      v_country=null;
      select min(id_country) from COUNTRY where alfa2=:v_country_code into :v_country;
      --    
      update DOCSPEC set taxhead=:v_taxhead, nds=:v_nds, custom=:v_custom, country=:v_country
        where id_dochead=:v_dochead and articul=:v_articul;
    end
    if (need_accept=1 and v_dochead is not null) then begin
      --   ( )
      update DOCHEAD set doc_state = -2, moddate = moddate + 0.00001 where id_dochead = :v_dochead;
    end
  end
  if (dochead is null) then dochead=-1;
  suspend;
end^

CREATE OR ALTER TRIGGER PLANOGRAM_AU_LOG FOR PLANOGRAM
ACTIVE AFTER UPDATE POSITION 0
as
declare variable v_place integer;
declare variable v_link_equipment_id integer;
begin
  if ((new.articul <> old.articul or new.num <> old.num or new.faces <> old.faces or
       new.levels <> old.levels or new.shelf <> old.shelf or new.equipment <> old.equipment) and
     (exists (select 1 from CONFIG where paramname = 'PlanogramUseChangeLog' and boolparam = 'T'))) then begin

    for select s.place_index, se.id
      from SECTIONS_EQUIPMENT se
      left join SECTIONS s on s.id = se.section
      where se.shortcut_equipment = new.equipment
      into :v_place, :v_link_equipment_id
    do update or insert into PLANOGRAM_CHANGE (place_id, equipment_id, shelf_id) values (:v_place,:v_link_equipment_id, new.shelf);
  end
end^

CREATE OR ALTER TRIGGER PLANOGRAM_AI_LOG FOR PLANOGRAM
ACTIVE AFTER INSERT POSITION 0
as
declare variable v_place integer;
declare variable v_faces integer;
declare variable v_levels integer;
declare variable v_link_equipment_id integer;
begin
  if (exists (select 1 from CONFIG where paramname = 'PlanogramUseChangeLog' and boolparam = 'T')) then begin
    select s.place_index
      from SECTIONS_EQUIPMENT se
      left join SECTIONS s on s.id = se.section
      where se.id = new.equipment
    into :v_place;

    select faces, levels
      from TMP_PLANOGRAM_CHANGE
      where place_id = :v_place and equipment_id = new.equipment and
            shelf_id = new.shelf and articul = new.articul and num = new.num
    into :v_faces, :v_levels;

    if (v_faces is null) then v_faces = 0; if (v_levels is null) then v_levels = 0;

    if (new.faces <> v_faces or new.levels <> v_levels) then begin
      update or insert into PLANOGRAM_CHANGE (place_id, equipment_id, shelf_id) values (:v_place,new.equipment, new.shelf);
      --     
      for select s.place_index, se.id
        from SECTIONS_EQUIPMENT se
        left join SECTIONS s on s.id = se.section
        where se.shortcut_equipment = new.equipment
        into :v_place, :v_link_equipment_id
      do update or insert into PLANOGRAM_CHANGE (place_id, equipment_id, shelf_id) values (:v_place,:v_link_equipment_id, new.shelf);
    end
  end
end^


create or alter procedure GET_PLANOGRAM_TEXT (
    PLACE_INDEX integer)
returns (
    PLTEXT varchar(1024))
AS
declare variable v_place varchar(80);
declare variable v_equipment varchar(80);
declare variable v_shelf varchar(80);
declare variable v_section varchar(80);
begin
  for select cl.name_clients,
             doubletrunc(s.kod,'00') || ' ' || s.name,
             doubletrunc(se.kod,'00') || ' ' || se.name,
             doubletrunc(ses.num,'00') || ' ' || ses.name
    from PLANOGRAM_CHANGE pch
    left join CLIENTS cl on cl.id_clients = pch.place_id
    left join SECTIONS_EQUIPMENT se on se.id = pch.equipment_id
    left join SHOP_EQUIPMENT_SHELVES ses on ses.id = pch.shelf_id
    left join SECTIONS s on s.id = se.section
    where pch.place_id = :place_index
    order by cl.name_clients,
             doubletrunc(s.kod,'00') || ' ' || s.name,
             doubletrunc(se.kod,'00') || ' ' || se.name,
             doubletrunc(ses.num,'00') || ' ' || ses.name
    into :v_place,
         :v_section,
         :v_equipment,
         :v_shelf
  do begin
    pltext = ' : "' || :v_place || '". : "' || :v_section || '".' || '     : "' || :v_equipment || '". : ' || :v_shelf || '".' || chr(13);
    suspend;
  end
end^

create or alter procedure EMAIL_PLACES (
    SESSION integer)
returns (
    CLIENT integer,
    CLIENT_NAME varchar(80),
    EMAIL varchar(255),
    SUBJECT varchar(255),
    FILENAME varchar(255),
    DOCHEAD integer,
    DOCKIND integer,
    DOCTYPE integer)
AS
begin
  session = session;
  dochead = 18820;
  dockind = 0;
  doctype = 0;

  for select cl.id_clients, cl.name_clients, cc.contact
    from CLIENTS cl
    left join TH_CLASSBYCLIENT cbcl on cbcl.client_index = cl.id_clients
    inner join CLIENT_CONTACT cc on cc.id_clients = cl.id_clients and cc.contact_type = 6
    where cl.client_type = 1 and exists (select 1 from PLANOGRAM_CHANGE pch where pch.place_id = cl.id_clients)
  into :client, :client_name, :email
  do begin
    subject = '    '||datetostr('ddmmyyyy',extractdate('now'));
    filename = 'pl_'||client;
    suspend;
  end
end^

CREATE OR ALTER TRIGGER PLANOGRAM_BD_LOG FOR PLANOGRAM
ACTIVE BEFORE DELETE POSITION 0
as
declare variable v_place integer;
begin
  if (exists (select 1 from CONFIG where paramname = 'PlanogramUseChangeLog' and boolparam = 'T')) then begin
    select s.place_index
      from SECTIONS_EQUIPMENT se
      left join SECTIONS s on s.id = se.section
      where se.id = old.equipment
    into :v_place;

    --      ,      ,    
    update or insert into TMP_PLANOGRAM_CHANGE (place_id, equipment_id, shelf_id, articul, faces, levels, num)
      values (:v_place, old.equipment, old.shelf, old.articul, old.faces, old.levels, old.num);

  end
end^

create or alter procedure PLANOGRAM_AFTER_CHANGE (
    EQUIPMENT_ID T_FID)
AS
declare variable v_superplace_id integer;
declare variable v_superpermis_id integer;
declare variable v_permis_id integer;
declare variable v_articul varchar(30);
declare variable v_global_set_permis smallint;
declare variable v_set_permis smallint;
declare variable v_trunclog smallint;
declare variable v_old_placement varchar(255);
declare variable v_placement varchar(255);
declare variable v_msg varchar(255);
declare variable v_user integer;
declare variable v_place_index integer;
declare variable v_place_name varchar(80);
declare variable v_equipment integer;
declare variable v_real_equipment integer;
declare variable v_log_place integer;
declare variable v_log_equipment integer;
declare variable v_log_shelf integer;
declare variable v_link_equipment integer;
declare variable v_use_log integer;
begin
  -- :
  -- 1.           
  -- 2.       

  if (exists (select 1 from CONFIG where paramname = 'PlanogramSetPermis' and boolparam = 'T') and
      exists(select 1 from CONFIG where paramname = 'UseSuperPermission' and boolparam = 'T'))
    then v_global_set_permis = 1;

  if (exists (select 1 from CONFIG where paramname = 'PlanogramUseChangeLog' and boolparam = 'T'))
    then v_use_log = 1;

  if (v_global_set_permis = 1) then begin
    --     
    select min(id) from SUPERPERMISSION_HEAD where is_default = 'T' into :v_superpermis_id;
    if (v_superpermis_id is null) then v_global_set_permis = 0;
  end

  select id from CUR_USER into :v_user;
  if (exists (select 1 from CONFIG where paramname = 'TruncLogCARDSCLA' and boolparam = 'T'))
    then v_trunclog = 1;

  --           
  for select se.id, c.id_clients, c.name_clients, coalesce(se.shortcut_equipment, se.id)
    from SECTIONS_EQUIPMENT se
    left join SECTIONS s on s.id = se.section
    left join CLIENTS c on c.id_clients = s.place_index
    where se.id = :equipment_id or se.shortcut_equipment = :equipment_id
    into :v_equipment, :v_place_index, :v_place_name, :v_real_equipment
  do begin
    v_set_permis = v_global_set_permis;

    if (v_set_permis = 1) then begin
      --      
      select superplace from GET_SUPERPLACE (:v_place_index, 3) into :v_superplace_id;
      if (v_superplace_id = -1) then v_set_permis = 0;
    end
    if (v_set_permis = 1) then begin
      --         
      select permission_pattern_id
        from SUPERPERMISSION
        where superpermission_head_id = :v_superpermis_id and
              superplace_head_id = :v_superplace_id
      into :v_permis_id;
      if (v_permis_id is null) then v_set_permis = 0;
    end
  
    --   
    for select articul, placement from TMP_PLANOGRAM_DEL
      where equipment = :v_equipment and reinserted = 0
      into :v_articul, :v_old_placement
    do begin
      --       
      v_msg = substring ('"' || v_place_name || '": ' || '  ' || v_old_placement from 1 for 255);
      if (v_trunclog = 1)
        then delete from LOG
               where object = 'CARDSCLA' and act = 'PLANOGRAM' and
                     keys = :v_articul and manager = :v_user and
                     comment = :v_msg;
      insert into LOG (object, act, keys, comment)
         values('CARDSCLA', 'PLANOGRAM', :v_articul, :v_msg);
  
      if (v_set_permis = 1) then begin
        --              ,
        --        
        if (not exists (select 1 from SUPERPLACE sp
                          left join SECTIONS s on s.place_index = sp.placeindex
                          left join SECTIONS_EQUIPMENT se on se.section = s.id
                          left join PLANOGRAM p on p.equipment = coalesce(se.shortcut_equipment, se.id) and p.articul = :v_articul
                          where sp.id = :v_superplace_id and p.articul is not null))
          then delete from CARDPERMISSION where articul = :v_articul and superplace_head_id = :v_superplace_id;
      end
    end
  
    for select distinct articul
      from PLANOGRAM
      where equipment = :v_real_equipment --    
      into :v_articul
    do begin
      v_old_placement = null;
      select placement from TMP_PLANOGRAM_DEL where articul = :v_articul and equipment = :v_equipment into :v_old_placement;
      select placement_codes from VW_CARDPLACEMENTS(:v_articul, null, :v_equipment) into :v_placement;
      if (v_old_placement is null or v_old_placement <> v_placement) then begin
        if (v_old_placement is null) then begin
          --       
          v_msg = substring ('"' || v_place_name || '": ' || '  ' || v_placement from 1 for 255);
        end else begin
          --       
          v_msg = substring ('"' || v_place_name || '": ' || '   ' || v_old_placement || '  ' || v_placement from 1 for 255);
        end
        if (v_trunclog = 1)
          then delete from LOG
                 where object = 'CARDSCLA' and act = 'PLANOGRAM' and
                       keys = :v_articul and manager = :v_user and
                       comment = :v_msg;
        insert into LOG (object, act, keys, comment)
          values('CARDSCLA', 'PLANOGRAM', :v_articul, :v_msg);
      end
  
      if (v_set_permis = 1) then begin
        --    ,      
        -- (   ,    )
        if (not exists(select 1 from CARDPERMISSION where articul = :v_articul and
                                                          superplace_head_id = :v_superplace_id ))
          then insert into CARDPERMISSION(articul, superplace_head_id, permission_pattern_id, comment)
                 values(:v_articul, :v_superplace_id, :v_permis_id, ' ');
      end
    end
  end

  if (v_use_log = 1) then begin --    ,    
    for select distinct tpc.place_id, tpc.equipment_id, tpc.shelf_id
      from TMP_PLANOGRAM_CHANGE tpc
      left join PLANOGRAM p on p.equipment = tpc.equipment_id and p.shelf = tpc.shelf_id and
                          p.articul = tpc.articul and p.num = tpc.num
      where tpc.equipment_id = :equipment_id and p.faces is null
      into :v_log_place, :v_log_equipment, :v_log_shelf
    do begin
      --    
      update or insert into PLANOGRAM_CHANGE (place_id, equipment_id, shelf_id)
        values (:v_log_place, :v_log_equipment, :v_log_shelf);

      --       
      for select s.place_index, se.id
        from SECTIONS_EQUIPMENT se
        left join SECTIONS s on s.id = se.section
        where se.shortcut_equipment = :v_log_equipment
        into :v_log_place, :v_link_equipment
      do update or insert into PLANOGRAM_CHANGE (place_id, equipment_id, shelf_id)
           values (:v_log_place, :v_link_equipment, :v_log_shelf);

    end
  end
end^

CREATE OR ALTER procedure DOCSPEC_TORG2_VIEW (
    DOCHEAD integer,
    FILIAL_INDEX integer)
returns (
    ID_DOCHEAD integer,
    ARTICUL varchar(30),
    NAME varchar(80),
    PRICERUB double precision,
    PRICECUR double precision,
    SUMMARUB double precision,
    SUMMACUR double precision,
    ASRT integer,
    ASRT_NAME varchar(80),
    MESURIMENT integer,
    NAME_MESURIMENT varchar(40),
    MES_COEFF double precision,
    DOC_QUANTITY double precision,
    PACK_QUANTITY double precision,
    Q_FACT double precision,
    Q_FACT_PACK double precision,
    Q_FACT_SUMMARUB double precision,
    Q_FACT_SUMMACUR double precision,
    Q_DEFECT double precision,
    Q_DEFECT_PACK double precision,
    Q_DEFECT_SUMMARUB double precision,
    Q_DEFECT_SUMMACUR double precision,
    Q_BREAK double precision,
    Q_BREAK_PACK double precision,
    Q_BREAK_SUMMARUB double precision,
    Q_BREAK_SUMMACUR double precision,
    Q_GOOD_DATE double precision,
    Q_GOOD_DATE_PACK double precision,
    Q_GOOD_DATE_SUMMARUB double precision,
    Q_GOOD_DATE_SUMMACUR double precision,
    Q_SHORTAGE double precision,
    Q_SHORTAGE_PACK double precision,
    Q_SHORTAGE_SUMMARUB double precision,
    Q_SHORTAGE_SUMMACUR double precision,
    Q_SURPLUS double precision,
    Q_SURPLUS_PACK double precision,
    Q_SURPLUS_SUMMARUB double precision,
    Q_SURPLUS_SUMMACUR double precision,
    COLOR_LIGHTING_NAME varchar(40),
    COLOR_LIGHTING_RGB integer,
    POS_NUMBER integer)
AS
declare variable v_use_color_lighting char(1);
declare variable v_base_mes integer;
declare variable v_show_t2q varchar(1);
declare variable v_temp_q double precision;
--declare variable v_distrib_quantity double precision;
begin
  --   -2

  select boolparam from CONFIG where paramname = 'UseCardColorLighting' into :v_use_color_lighting;
  select boolparam from CONFIG where paramname = 'SpecShowTorg2Quantity' into :v_show_t2q;

  -- ,     
  for select ds.id_dochead, ds.articul, cs.name, dse.asrt, r.name, cs.mesuriment,
             dse.pack, m.name_mesuriment, dse.quantity, dse.pack_quantity,
             dse.pricerub, dse.pricecur, dse.pricerub * dse.quantity, dse.pricecur * dse.quantity,
             coalesce(dst2.q_defect, 0), coalesce(dst2.q_break, 0), coalesce(dst2.q_good_date, 0),
             coalesce(dst2.q_shortage, 0), coalesce(dst2.q_surplus, 0),ds.pos_number
    from DOCSPEC ds
    left join CARDSCLA cs on ds.articul = cs.articul
    left join VW_ASSORTIMENT_DOCSPEC(0, ds.id_dochead, ds.articul, ds.rz, ds.mesuriment,
                                     ds.quantity, ds.pack_quantity, ds.pricerub, ds.pricecur,
                                     ds.pos_number, ds.barcode, ds.comment) dse on 1=1
    left join MESURIMENT m on dse.pack = m.id_mesuriment
    left join GET_ASRT_PARAMS(ds.articul, dse.asrt) r on 1=1
    left join DOCSPEC_TORG2 dst2 on dst2.dochead = :dochead and dst2.articul = ds.articul and
                                    dst2.pack = dse.pack and dst2.asrt = dse.asrt
    where ds.id_dochead = :dochead
    into :id_dochead, :articul,:name, :asrt, :asrt_name, :v_base_mes,
         :mesuriment,:name_mesuriment, :doc_quantity, :pack_quantity,
         :pricerub, :pricecur, :summarub, :summacur,
         :q_defect, :q_break, :q_good_date,
         :q_shortage, :q_surplus,:pos_number
  do begin

/*    select sum(quantity) from docspec_distrib
    where id_dochead = :id_dochead and articul = :articul
    group by id_dochead, articul
    into :v_distrib_quantity;
    if (v_distrib_quantity is null) then v_distrib_quantity = 0;  --Hash     (     ,      )
*/
    select coeff from GET_MESURIM_COEFF(:articul, :mesuriment, :v_base_mes) into mes_coeff;

    q_defect_pack = q_defect / mes_coeff;
    q_defect_summarub = q_defect * pricerub;
    q_defect_summacur = q_defect * pricecur;

    q_break_pack = q_break / mes_coeff;
    q_break_summarub = q_break * pricerub;
    q_break_summacur = q_break * pricecur;

    q_good_date_pack = q_good_date / mes_coeff;
    q_good_date_summarub = q_good_date * pricerub;
    q_good_date_summacur = q_good_date * pricecur;

    q_shortage_pack = q_shortage / mes_coeff;
    q_shortage_summarub = q_shortage * pricerub;
    q_shortage_summacur = q_shortage * pricecur;

    q_surplus_pack = q_surplus / mes_coeff;
    q_surplus_summarub = q_surplus * pricerub;
    q_surplus_summacur = q_surplus * pricecur;

    if (v_show_t2q = 'T') then begin
      q_fact = doc_quantity + q_defect + q_break + q_good_date + q_shortage - q_surplus;
      q_fact_pack = pack_quantity + q_defect_pack + q_break_pack + q_good_date_pack + q_shortage_pack - q_surplus_pack;
      v_temp_q = :q_fact;
      q_fact = :doc_quantity;
      doc_quantity = :v_temp_q;
      v_temp_q = :q_fact_pack;
      q_fact_pack = :pack_quantity;
      pack_quantity = :v_temp_q;
    end else begin
      q_fact = doc_quantity - q_defect - q_break - q_good_date - q_shortage + q_surplus;
      q_fact_pack = pack_quantity - q_defect_pack - q_break_pack - q_good_date_pack - q_shortage_pack + q_surplus_pack;
    end
    q_fact_summarub = q_fact * pricerub;
    q_fact_summacur = q_fact * pricecur;
    summarub = doc_quantity * pricerub;
    summacur = doc_quantity * pricecur;

    --    
    if (v_use_color_lighting = 'T')
      then select color_lighting_name, color_lighting_rgb
             from GET_CARD_COLORLIGHTING(:articul, :filial_index)
           into :color_lighting_name, :color_lighting_rgb;
    suspend;
  end
end^

CREATE OR ALTER procedure DOCSPEC_DISTRIBUTION_VIEW (
    DOCHEAD integer,
    FILIAL_INDEX integer)
returns (
    ID_DOCHEAD integer,
    ARTICUL varchar(30),
    NAME varchar(80),
    PRICERUB double precision,
    PRICECUR double precision,
    SUMMARUB double precision,
    SUMMACUR double precision,
    ASRT integer,
    ASRT_NAME varchar(80),
    MESURIMENT integer,
    NAME_MESURIMENT varchar(40),
    MES_COEFF double precision,
    DOC_QUANTITY double precision,
    PACK_QUANTITY double precision,
    COLOR_LIGHTING_NAME varchar(40),
    COLOR_LIGHTING_RGB integer,
    FREE_QUANTITY double precision,
    TORG2_QUANTITY double precision,
    POS_NUMBER integer)
AS
declare variable v_use_color_lighting char(1);
declare variable v_base_mes integer;
declare variable v_showfactq char(1);
begin
  --   " "

  select boolparam from CONFIG where paramname = 'UseCardColorLighting' into :v_use_color_lighting;
  select boolparam from config where paramname = 'SpecShowTorg2Quantity' into :v_showfactq;


  -- ,     
  for select ds.id_dochead, ds.articul, cs.name, dse.asrt, r.name, cs.mesuriment,
             dse.pack, m.name_mesuriment, dse.quantity, dse.pack_quantity,
             dse.pricerub, dse.pricecur, dse.pricerub * dse.quantity, dse.pricecur * dse.quantity, dtv.q_fact, ds.pos_number
    from DOCSPEC ds
    left join CARDSCLA cs on ds.articul = cs.articul
    left join VW_ASSORTIMENT_DOCSPEC(0, ds.id_dochead, ds.articul, ds.rz, ds.mesuriment,
                                     ds.quantity, ds.pack_quantity, ds.pricerub, ds.pricecur,
                                     ds.pos_number, ds.barcode, ds.comment) dse on 1=1
    left join docspec_torg2_view (ds.id_dochead, :filial_index) dtv on dtv.articul = ds.articul and dtv.asrt = dse.asrt and dtv.mesuriment = dse.pack
    left join MESURIMENT m on dse.pack = m.id_mesuriment
    left join GET_ASRT_PARAMS(ds.articul, dse.asrt) r on 1=1
--    left join DOCSPEC_TORG2 dst2 on dst2.dochead = :dochead and dst2.articul = ds.articul and
--                                    dst2.pack = dse.pack and dst2.asrt = dse.asrt
    where ds.id_dochead = :dochead
    into :id_dochead, :articul,:name, :asrt, :asrt_name, :v_base_mes,
         :mesuriment,:name_mesuriment, :doc_quantity, :pack_quantity,
         :pricerub, :pricecur, :summarub, :summacur, :torg2_quantity, :pos_number
  do begin
    select coeff from GET_MESURIM_COEFF(:articul, :mesuriment, :v_base_mes) into mes_coeff;

    if (torg2_quantity is not null) then free_quantity=:torg2_quantity;
    else free_quantity = :doc_quantity;

    if (torg2_quantity is null) then torg2_quantity=0;
    --    
    if (v_use_color_lighting = 'T')
      then select color_lighting_name, color_lighting_rgb
             from GET_CARD_COLORLIGHTING(:articul, :filial_index)
           into :color_lighting_name, :color_lighting_rgb;

    if (:v_showfactq = 'T') then free_quantity = :doc_quantity;
    suspend;
  end
end^

create or alter procedure DOCHEAD_RETURN_PAID (
    V_DOCHEAD integer,
    V_EPS double precision)
returns (
    OUT_DOCHEAD integer,
    IN_DOCHEAD integer,
    DOCINDEX varchar(10),
    DOC_DATE date,
    ID_DOCTYPE integer,
    NAME_DOCTYPE varchar(40),
    EXT_DOCINDEX t_ext_doc_index,
    EXT_DOC_DATE date,
    ID_EXT_DOCTYPE integer,
    NAME_EXT_DOCTYPE varchar(40),
    ID_OPERATION integer,
    NAME_OPERATION varchar(40),
    ID_PLACE integer,
    NAME_PLACE varchar(80),
    ID_CLIENT integer,
    NAME_CLIENT varchar(80),
    ARTICUL varchar(30),
    NAME varchar(80),
    QUANTITY double precision,
    SUMMARUB double precision,
    SUMMACUR double precision,
    PAYQUANTITY double precision,
    PAYRUB double precision,
    PAYCUR double precision)
AS
declare variable v_dockind integer;
declare variable v_opertype integer;
begin
  v_eps = v_eps; out_dochead = out_dochead;
  select dh.dockind, op.opertype
    from DOCHEAD dh
    left join OPERATIONS op on dh.operation = op.id_operation
    where id_dochead = :v_dochead
  into :v_dockind, :v_opertype;
  if (not (v_dockind = 37 or v_dockind in (1,9) and v_opertype = 1)) then exit;

  for select dochead, articul, quantity
    from TMP_SPEC_CORRECT_RET
    into :in_dochead, :articul, :payquantity
  do begin
    select quantity, quantity * pricerub, quantity * pricecur, :payquantity * pricerub, :payquantity * paymentcur
      from DOCSPEC where id_dochead = :in_dochead and articul = :articul
    into :quantity, :summarub, :summacur, :payrub, :paycur;
    select name from CARDSCLA where articul = :articul into :name;
    select docindex, doctype, doc_date, ext_docindex, ext_doctype,
           ext_doc_date, client_index, client2_index, operation
      from DOCHEAD where id_dochead = :in_dochead
      into :docindex, :id_doctype, :doc_date, :ext_docindex, :id_ext_doctype,
           :ext_doc_date, :id_client, :id_place, :id_operation;
    select name_doctype from DOCTYPE where id_doctype = :id_doctype into :name_doctype;
    select name_ext_doctype from EXT_DOCTYPE where id_ext_doctype = :id_ext_doctype into :name_ext_doctype;
    select name_operation from OPERATIONS where id_operation = :id_operation into :name_operation;
    select name_clients from CLIENTS where id_clients = :id_client into :name_client;
    select name_clients from CLIENTS where id_clients = :id_place into :name_place;
    suspend;
  end
end^

CREATE OR ALTER procedure JOIN_ART_CARD (
    V_SESSION integer,
    V_ARTICUL1 varchar(30),
    V_ARTICUL2 varchar(30))
AS
declare variable v_card_bar integer;
declare variable v_card_pack integer;
declare variable v_card_supp integer;
declare variable v_card_clname integer;
declare variable v_card_price integer;
declare variable v_card_discount integer;
declare variable v_card_nlose integer;
--declare variable v_card_attrib integer;
--declare variable v_card_rz integer;
declare variable v_card_zapas integer;
declare variable v_int integer;
declare variable v_barcode varchar(30);
declare variable v_shopindex integer;
declare variable v_filialindex integer;
declare variable v_client_index integer;
declare variable v_priority integer;
declare variable v_comment varchar(255);
declare variable v_pack integer;
declare variable v_quantity double precision;
declare variable v_wmesurim integer;
declare variable v_netto double precision;
declare variable v_brutto double precision;
declare variable v_smesurim integer;
declare variable v_slength double precision;
declare variable v_swidth double precision;
declare variable v_sheight double precision;
declare variable v_turn varchar(1);
declare variable v_name varchar(80);
declare variable v_clarticul varchar(30);
declare variable v_discount_rub double precision;
declare variable v_discount_cur double precision;
declare variable v_round_to_rub integer;
declare variable v_round_to_cur integer;
declare variable v_price_rub double precision;
declare variable v_price_rub1 double precision;
declare variable v_price_cur double precision;
declare variable v_discount double precision;
declare variable v_modmanager integer;
declare variable v_dochead integer;
declare variable v_dochead1 integer;
declare variable v_min_day_fix integer;
declare variable v_max_day_fix integer;
declare variable v_min_level_fix double precision;
declare variable v_max_level_fix double precision;
declare variable v_order_coeff double precision;
declare variable v_max_round integer;
declare variable v_min_round integer;
declare variable v_min_subgood double precision;
declare variable v_max_subgood double precision;
declare variable v_krit_level double precision;
declare variable v_use_zapas double precision;
declare variable v_use_order_coeff integer;
declare variable v_use_krit_level integer;
declare variable v_use_order_pack integer;
declare variable v_order_pack integer;
declare variable v_use_planogram integer;
declare variable v_use_speed_period integer;
declare variable v_speed_period integer;
declare variable v_use_overincome smallint;
declare variable v_overincome double precision;
declare variable v_use_order_weekday integer;
declare variable v_order_weekday_1 integer;
declare variable v_order_weekday_2 integer;
declare variable v_order_weekday_3 integer;
declare variable v_order_weekday_4 integer;
declare variable v_order_weekday_5 integer;
declare variable v_order_weekday_6 integer;
declare variable v_order_weekday_7 integer;
declare variable v_use_kratn integer;
declare variable v_kratn double precision;
declare variable v_l integer;
declare variable v_m integer;
declare variable v_5 integer;
declare variable v_d date;
declare variable v_d1 date;
declare variable v_price_kind integer;
declare variable v_mesuriment1 integer;
declare variable v_mesuriment2 integer;
declare variable v_gtin varchar(30);
declare variable v_asrt integer;
begin
  v_card_bar=0; v_card_pack=0; v_card_supp=0;
  v_card_clname=0; v_card_price=0; v_card_discount=0;
  v_card_nlose=0; v_card_zapas=0; -- v_card_attrib=0; v_card_rz=0;
  select v_num from PARAMS
    where session=:v_session and class='JoinArt' and name='card_bar'
    into :v_card_bar;
  select v_num from PARAMS
    where session=:v_session and class='JoinArt' and name='card_pack'
    into :v_card_pack;
  select v_num from PARAMS
    where session=:v_session and class='JoinArt' and name='card_supp'
    into :v_card_supp;
  select v_num from PARAMS
    where session=:v_session and class='JoinArt' and name='card_clname'
    into :v_card_clname;
  select v_num from PARAMS
    where session=:v_session and class='JoinArt' and name='card_price'
    into :v_card_price;
  select v_num from PARAMS
    where session=:v_session and class='JoinArt' and name='card_discount'
    into :v_card_discount;
  select v_num from PARAMS
    where session=:v_session and class='JoinArt' and name='card_nlose'
    into :v_card_nlose;
  select v_num from PARAMS
    where session=:v_session and class='JoinArt' and name='card_zapas'
    into :v_card_zapas;

  -- - (   ) ( articul2   articul1)
  if (v_card_bar=1) then begin
    for select b.barcode, cr.asrt
          from bar b left join cardasrt cr on cr.articul=:v_articul1 and cr.name=(select caa.name from cardasrt caa where caa.articul=:v_articul2 and caa.asrt=b.rz rows 1)
          where b.articul=:v_articul2
        into :v_barcode,:v_int do begin
      update bar set articul=:v_articul1,rz=:v_int,postfix=-1 where barcode=:v_barcode;
    end
  end

  --   (articul2  , articul1 )
  if (v_card_nlose = 1) then begin
    for select cl2.place_or_group, cl2.nloss, cl2.comment
      from CARDNLOSS cl2
      left join CARDNLOSS cl1 on cl1.articul = :v_articul1 and
                                 cl2.nloss = cl1.nloss and
                                 cl2.place_or_group = cl1.place_or_group
      where cl2.articul = :v_articul2 and cl1.nloss is null
      into :v_client_index, :v_int, :v_comment
    do begin
      insert into CARDNLOSS(articul, place_or_group, nloss, comment)
        values(:v_articul1, :v_client_index, :v_int, :v_comment);
    end
  end

  --   (articul2  , articul1 )
  if (v_card_supp=1) then begin
    for select cs2.shopindex,cs2.filialindex,cs2.client_index,cs2.priority,cs2.comment
           from cardsupp cs2
            left join cardsupp cs1 on cs2.shopindex=cs1.shopindex and cs2.filialindex=cs1.filialindex and cs1.articul=:v_articul1 and cs2.client_index=cs1.client_index
          where cs2.articul=:v_articul2 and cs1.shopindex is null
        into :v_shopindex,:v_filialindex,:v_client_index,:v_priority,:v_comment do begin
      insert into cardsupp(shopindex,filialindex,articul,client_index,priority,comment)
        values(:v_shopindex,:v_filialindex,:v_articul1,:v_client_index,:v_priority,:v_comment);
    end
  end

  --      (articul2  , articul1 )
  if (v_card_pack = 1) then begin
    select mesuriment from CARDSCLA where articul = :v_articul1 into :v_mesuriment1;
    select mesuriment from CARDSCLA where articul = :v_articul2 into :v_mesuriment2;
    for select cp2.pack, cp2.quantity, cp2.wmesurim, cp2.netto, cp2.brutto, cp2.smesurim,
               cp2.slength, cp2.swidth, cp2.sheight, cp2.turn, cp2.comment
      from CARDPACK cp2
      left join CARDPACK cp1 on cp1.articul = :v_articul1 and cp2.pack = cp1.pack
      where cp2.articul = :v_articul2 and cp1.pack is null
      into :v_pack, :v_quantity, :v_wmesurim, :v_netto, :v_brutto, :v_smesurim,
           :v_slength, :v_swidth, :v_sheight, :v_turn, :v_comment
    do begin
      if (not (v_pack = v_mesuriment2 and  v_mesuriment1 <> v_mesuriment2))
        then insert into CARDPACK(articul,pack,quantity,wmesurim,netto,brutto,smesurim,slength,swidth,sheight,turn,comment)
               values(:v_articul1,:v_pack,:v_quantity,:v_wmesurim,:v_netto,:v_brutto,:v_smesurim,:v_slength,:v_swidth,:v_sheight,:v_turn,:v_comment);
    end
    for select cm2.mesuriment,cm2.coeff,cm2.comment
           from cardmesurim cm2
            left join cardmesurim cm1 on cm1.articul=:v_articul1 and cm2.mesuriment=cm1.mesuriment
          where cm2.articul=:v_articul2 and cm1.mesuriment is null
        into :v_int,:v_quantity,:v_comment do begin
      insert into cardmesurim(articul,mesuriment,coeff,comment)
        values(:v_articul1,:v_int,:v_quantity,:v_comment);
    end
  end

  -- (, GTIN)  (articul2  , articul1 )
  if (v_card_clname = 1) then begin
    for select cc2.client_index, cc2.name, cc2.comment, cc2.clarticul, cc2.gtin, cc2.asrt
      from CLCARDSCLA cc2
      left join CLCARDSCLA cc1 on cc1.articul = :v_articul1 and cc2.client_index = cc1.client_index and cc2.clarticul = cc1.clarticul
      where cc2.articul=:v_articul2 and cc1.client_index is null
      into :v_client_index,:v_name,:v_comment,:v_clarticul,:v_gtin, :v_asrt
    do begin
      insert into clcardscla(articul,client_index,name,comment,clarticul,gtin,asrt)
        values(:v_articul1,:v_client_index,:v_name,:v_comment,:v_clarticul,:v_gtin,:v_asrt);
    end
  end

  /*  (articul2  , articul1 ) */
  if (v_card_discount=1) then begin
    for select d2.filial_index,d2.discount_rub,d2.discount_cur,d2.round_to_rub,d2.round_to_cur
           from discount d2
            left join discount d1 on d1.articul=:v_articul1 and d2.filial_index=d1.filial_index
          where d2.articul=:v_articul2 and d1.filial_index is null
        into :v_int,:v_discount_rub,:v_discount_cur,:v_round_to_rub,:v_round_to_cur do begin
      insert into discount(articul,filial_index,discount_rub,discount_cur,round_to_rub,round_to_cur)
        values(:v_articul1,:v_int,:v_discount_rub,:v_discount_cur,:v_round_to_rub,:v_round_to_cur);
    end
    /*    articul1      articul1  articul2 */
    for select price_kind, discount from disccardlim
          where articul=:v_articul2
        into :v_price_kind,:v_discount_rub do begin
      if (v_discount_rub is null) then v_discount_rub=0;
      v_discount_cur=null;
      select discount from disccardlim where articul=:v_articul1 and price_kind=:v_price_kind
        into :v_discount_cur;
      if (v_discount_cur is null)
        then insert into disccardlim(articul,price_kind,discount) values(:v_articul1,:v_price_kind,:v_discount_rub);
      else if (v_discount_rub<v_discount_cur) then
        update disccardlim set discount=:v_discount_rub where articul=:v_articul1 and price_kind=:v_price_kind;
    end
  end

  /*  (  '  ') ( : articul2  , articul1 ) */
  if (v_card_price=1) then begin

    if (exists(select 1 from config where paramname='SetLastInputPrice' and boolparam='T'))
      then v_l=1; else v_l=0;
    if (exists(select 1 from config where paramname='SetMaxInputPrice' and boolparam='T'))
      then v_m=1; else v_m=0;
    if (exists(select 1 from config where paramname='SetMaxRemainsPrice' and boolparam='T'))
      then v_5=1; else v_5=0;

    for select d2.price_kind,d2.quantity,d2.price_rub,d2.price_cur,d2.discount,
               d2.round_to_rub,d2.round_to_cur,d2.modmanager,d2.dochead,
               p.pricetype_pricekind,d1.price_rub,d1.dochead
          from disccard d2
            left join pricekind p on d2.price_kind=p.id_pricekind
            left join disccard d1 on d1.articul=:v_articul1 and d2.price_kind=d1.price_kind and d2.quantity=d1.quantity
          where d2.articul=:v_articul2 and p.pricetype_pricekind in ('N','L','M','5') /* and d1.price_kind is null */
        into :v_int,:v_quantity,:v_price_rub,:v_price_cur,:v_discount,:v_round_to_rub,
             :v_round_to_cur,:v_modmanager,:v_dochead,:v_turn,:v_price_rub1,:v_dochead1  do begin

      if (v_turn='N' and v_price_rub1 is null) then begin
        insert into disccard(articul,price_kind,quantity,price_rub,price_cur,discount,round_to_rub,round_to_cur,modmanager,dochead)
          values(:v_articul1,:v_int,:v_quantity,:v_price_rub,:v_price_cur,:v_discount,:v_round_to_rub,:v_round_to_cur,:v_modmanager,:v_dochead);
      end
      if (v_turn='L' and v_l=1) then begin
        if (v_price_rub1 is null) then begin
          insert into disccard(articul,price_kind,quantity,price_rub,price_cur,discount,round_to_rub,round_to_cur,modmanager,dochead)
            values(:v_articul1,:v_int,:v_quantity,:v_price_rub,:v_price_cur,:v_discount,:v_round_to_rub,:v_round_to_cur,:v_modmanager,:v_dochead);
        end else begin
          select doc_date from dochead d where id_dochead=:v_dochead into :v_d;
          select doc_date from dochead d where id_dochead=:v_dochead1 into :v_d1;
          if (v_d1<v_d or (v_d1=v_d and v_price_rub1<v_price_rub)) then begin
            delete from disccard where articul=:v_articul1 and price_kind=:v_int and quantity=:v_quantity;
            insert into disccard(articul,price_kind,quantity,price_rub,price_cur,discount,round_to_rub,round_to_cur,modmanager,dochead)
              values(:v_articul1,:v_int,:v_quantity,:v_price_rub,:v_price_cur,:v_discount,:v_round_to_rub,:v_round_to_cur,:v_modmanager,:v_dochead);
          end
        end
      end
      if ((v_turn='M' and v_m=1) or (v_turn='5' and v_5=1)) then begin
        if (v_price_rub1 is null) then begin
          insert into disccard(articul,price_kind,quantity,price_rub,price_cur,discount,round_to_rub,round_to_cur,modmanager,dochead)
            values(:v_articul1,:v_int,:v_quantity,:v_price_rub,:v_price_cur,:v_discount,:v_round_to_rub,:v_round_to_cur,:v_modmanager,:v_dochead);
        end else begin
          if (v_price_rub1<v_price_rub) then begin
            delete from disccard where articul=:v_articul1 and price_kind=:v_int and quantity=:v_quantity;
            insert into disccard(articul,price_kind,quantity,price_rub,price_cur,discount,round_to_rub,round_to_cur,modmanager,dochead)
              values(:v_articul1,:v_int,:v_quantity,:v_price_rub,:v_price_cur,:v_discount,:v_round_to_rub,:v_round_to_cur,:v_modmanager,:v_dochead);
          end
        end
      end
    end
  end

  --  (articul2  , articul1 )
  if (v_card_zapas = 1) then begin
    for select z2.place_index,
               z2.use_zapas, z2.min_level_fix, z2.max_level_fix, z2.min_day_fix, z2.max_day_fix,
               z2.min_subgood, z2.max_subgood, z2.min_round, z2.max_round,
               z2.use_order_coeff, z2.order_coeff, z2.use_krit_level, z2.krit_level,
               z2.use_order_pack, z2.order_pack, z2.use_planogram, z2.use_speed_period, z2.speed_period,
               z2.use_overincome, z2.overincome, z2.use_order_weekday, z2.order_weekday_1, z2.order_weekday_2, z2.order_weekday_3,
               z2.order_weekday_4, z2.order_weekday_5, z2.order_weekday_6, z2.order_weekday_7,
               z2.use_kratn, z2.kratn
      from ZAPAS z2
      left join ZAPAS z1 on z1.articul = :v_articul1 and z2.place_index = z1.place_index
      where z2.articul = :v_articul2 and z1.place_index is null
      into :v_int,
           :v_use_zapas, :v_min_level_fix, :v_max_level_fix, :v_min_day_fix, :v_max_day_fix,
           :v_min_subgood, :v_max_subgood, :v_min_round, :v_max_round,
           :v_use_order_coeff, :v_order_coeff, :v_use_krit_level, :v_krit_level,
           :v_use_order_pack, :v_order_pack, :v_use_planogram, :v_use_speed_period, :v_speed_period,
           :v_use_overincome, :v_overincome, :v_use_order_weekday, :v_order_weekday_1, :v_order_weekday_2, :v_order_weekday_3,
           :v_order_weekday_4, :v_order_weekday_5, :v_order_weekday_6, :v_order_weekday_7,
           :v_use_kratn, :v_kratn
    do begin
      insert into ZAPAS(articul, place_index,
                        use_zapas, min_level_fix, max_level_fix, min_day_fix, max_day_fix,
                        min_subgood, max_subgood, min_round, max_round,
                        use_order_coeff, order_coeff, use_krit_level, krit_level,
                        use_order_pack, order_pack, use_planogram, use_speed_period, speed_period,
                        use_overincome, overincome, use_order_weekday, order_weekday_1, order_weekday_2, order_weekday_3, order_weekday_4,
                        order_weekday_5, order_weekday_6, order_weekday_7,
                        use_kratn, kratn)
        values(:v_articul1, :v_int,
               :v_use_zapas, :v_min_level_fix, :v_max_level_fix, :v_min_day_fix, :v_max_day_fix,
               :v_min_subgood, :v_max_subgood, :v_min_round, :v_max_round,
               :v_use_order_coeff, :v_order_coeff, :v_use_krit_level, :v_krit_level,
               :v_use_order_pack, :v_order_pack, :v_use_planogram, :v_use_speed_period, :v_speed_period,
               :v_use_overincome, :v_overincome, :v_use_order_weekday, :v_order_weekday_1, :v_order_weekday_2, :v_order_weekday_3, :v_order_weekday_4,
               :v_order_weekday_5, :v_order_weekday_6, :v_order_weekday_7,
               :v_use_kratn, :v_kratn);
    end
    for select t.asrt1, z2.place_index,
               z2.use_zapas, z2.min_level_fix, z2.max_level_fix, z2.min_day_fix, z2.max_day_fix,
               z2.min_subgood, z2.max_subgood, z2.min_round, z2.max_round,
               z2.use_order_coeff, z2.order_coeff, z2.use_krit_level, z2.krit_level,
               z2.use_order_pack, z2.order_pack, z2.use_planogram, z2.use_speed_period, z2.speed_period,
               z2.use_overincome, z2.overincome, z2.use_order_weekday, z2.order_weekday_1, z2.order_weekday_2, z2.order_weekday_3,
               z2.order_weekday_4, z2.order_weekday_5, z2.order_weekday_6, z2.order_weekday_7,
               z2.use_kratn, z2.kratn
      from ZAPAS_ASRT z2
      left join TMP_JOIN_ASRT t on t.session = :v_session and t.asrt2 = z2.asrt
      left join ZAPAS_ASRT z1 on z1.articul = :v_articul1 and t.asrt1 = z1.asrt and z2.place_index = z1.place_index
      where z2.articul = :v_articul2 and z1.place_index is null
      into :v_l, :v_int,
           :v_use_zapas, :v_min_level_fix, :v_max_level_fix, :v_min_day_fix, :v_max_day_fix,
           :v_min_subgood, :v_max_subgood, :v_min_round, :v_max_round,
           :v_use_order_coeff, :v_order_coeff, :v_use_krit_level, :v_krit_level,
           :v_use_order_pack, :v_order_pack, :v_use_planogram, :v_use_speed_period, :v_speed_period,
           :v_use_overincome, :v_overincome, :v_use_order_weekday, :v_order_weekday_1, :v_order_weekday_2, :v_order_weekday_3,
           :v_order_weekday_4, :v_order_weekday_5, :v_order_weekday_6, :v_order_weekday_7,
           :v_use_kratn, :v_kratn
    do begin
      insert into ZAPAS_ASRT(articul, asrt, place_index,
                             use_zapas, min_level_fix, max_level_fix, min_day_fix, max_day_fix,
                             min_subgood, max_subgood, min_round, max_round,
                             use_order_coeff, order_coeff, use_krit_level, krit_level,
                             use_order_pack, order_pack, use_planogram, use_speed_period, speed_period,
                             use_overincome, overincome, use_order_weekday, order_weekday_1, order_weekday_2, order_weekday_3, order_weekday_4,
                             order_weekday_5, order_weekday_6, order_weekday_7,
                             use_kratn, kratn)
        values(:v_articul1, :v_l, :v_int,
               :v_use_zapas, :v_min_level_fix, :v_max_level_fix, :v_min_day_fix, :v_max_day_fix,
               :v_min_subgood, :v_max_subgood, :v_min_round, :v_max_round,
               :v_use_order_coeff, :v_order_coeff, :v_use_krit_level, :v_krit_level,
               :v_use_order_pack, :v_order_pack, :v_use_planogram, :v_use_speed_period, :v_speed_period,
               :v_use_overincome, :v_overincome, :v_use_order_weekday, :v_order_weekday_1, :v_order_weekday_2, :v_order_weekday_3, :v_order_weekday_4,
               :v_order_weekday_5, :v_order_weekday_6, :v_order_weekday_7,
               :v_use_kratn, :v_kratn);
    end
  end
end^

create or alter procedure JOIN_ART_TEST (
    V_SESSION integer,
    V_ARTICUL1 varchar(30),
    V_ARTICUL2 varchar(30))
returns (
    ERRCODE integer,
    ERRMSG varchar(255))
AS
declare variable v_dochead integer;
declare variable v_docindex varchar(10);
declare variable v_basedocindex varchar(10);
declare variable v_dockind integer;
declare variable v_accept char;
declare variable v_doc integer;
declare variable v_basedoc integer;
declare variable v_pricerub double precision;
declare variable v_pricecur double precision;
declare variable v_basepricerub double precision;
declare variable v_basepricecur double precision;
declare variable v_ignore_nds integer;
begin

  /* v_ignore_nds -        */
  select v_num from params
    where session=:v_session and class='JoinArt' and name='ignore_nds'
  into :v_ignore_nds;

  /*          (   v_ignore_nds=0) */
  for select ds1.id_dochead,ds1.doctype
        from docspec ds1
          left join docspec ds2
            on ds1.id_dochead=ds2.id_dochead and ds2.articul=:v_articul2
        where ds1.articul=:v_articul1 and ds1.dockind in (0,1) and
              ds2.id_dochead is not null and
              (ds1.taxhead<>ds2.taxhead or ds1.taxhead1<>ds2.taxhead1)
        into :v_dochead,:v_dockind do begin

    if (v_ignore_nds=0 or (v_dockind<>1000 and v_dockind<>1001)) then begin
      select docindex from dochead where id_dochead=:v_dochead into :v_docindex;
      errcode = 1;
      errmsg = '  '||v_docindex||'    ';
      suspend; exit;
    end
  end
  for select ds1.id_dochead
        from cut_docspec ds1
          left join cut_docspec ds2
            on ds1.id_dochead=ds2.id_dochead and ds2.articul=:v_articul2
        where ds1.articul=:v_articul1 and ds1.dockind in (0,1) and
              ds2.id_dochead is not null and
              ds1.taxhead<>ds2.taxhead
        into :v_dochead do begin
    select docindex from cut_dochead where id_dochead=:v_dochead into :v_docindex;
    errcode = 1;
    errmsg = '   '||v_docindex||'    ';
    suspend; exit;
  end

  /*           ( ) */
  for select ds1.id_dochead,ds1.dockind
        from docspec ds1
          left join docspec ds2
            on ds1.id_dochead=ds2.id_dochead and ds2.articul=:v_articul2
        where ds1.articul=:v_articul1 and ds1.dockind in (0,1,3,14) and
              ds2.id_dochead is not null and
              (ds1.linkquantity>0 or ds2.linkquantity>0)
        into :v_dochead,:v_dockind do begin
    select docindex,accept
      from dochead
      where id_dochead=:v_dochead
      into :v_docindex,:v_accept;
    if (v_accept='T') then begin
      for select dochead,basedochead
            from payspec
            where (dochead=:v_dochead or basedochead=:v_dochead) and
                  basedockind in (3,14) and
                  (articul=:v_articul1 or articul=:v_articul2)
            group by dochead,basedochead
            into :v_doc,:v_basedoc do begin
        select sum(pricerub*quantity)/sum(quantity),
               sum(pricecur*quantity)/sum(quantity)
          from docspec
          where id_dochead=:v_doc and
                (articul=:v_articul1 or articul=:v_articul2)
          into :v_pricerub,:v_pricecur;
        select sum(pricerub*quantity)/sum(quantity),
               sum(pricecur*quantity)/sum(quantity)
          from docspec
          where id_dochead=:v_basedoc and
                (articul=:v_articul1 or articul=:v_articul2)
          into :v_basepricerub,:v_basepricecur;
        if (v_pricerub<>v_basepricerub or v_pricecur<>v_basepricecur) then begin
          select docindex from dochead where id_dochead=:v_doc into :v_docindex;
          select docindex from dochead where id_dochead=:v_basedoc into :v_basedocindex;
          errcode = 2;
          errmsg = '     : '||
                   v_docindex||' rub='||v_pricerub||' cur='||v_pricecur||'   '||
                   v_basedocindex||' rub='||v_basepricerub||' cur='||v_basepricecur;
          suspend; exit;
        end
      end
    end
  end
  for select ds1.id_dochead,ds1.dockind
        from cut_docspec ds1
          left join cut_docspec ds2
            on ds1.id_dochead=ds2.id_dochead and ds2.articul=:v_articul2
        where ds1.articul=:v_articul1 and ds1.dockind in (0,1,3,14) and
              ds2.id_dochead is not null and
              (ds1.linkquantity>0 or ds2.linkquantity>0)
        into :v_dochead,:v_dockind do begin

    for select dochead,basedochead
          from cut_payspec
          where (dochead=:v_dochead or basedochead=:v_dochead) and
                basedockind in (3,14) and
                (articul=:v_articul1 or articul=:v_articul2)
          group by dochead,basedochead
          into :v_doc,:v_basedoc do begin
      select sum(pricerub*quantity)/sum(quantity),
             sum(pricecur*quantity)/sum(quantity)
        from cut_docspec
        where id_dochead=:v_doc and
             (articul=:v_articul1 or articul=:v_articul2)
      into :v_pricerub,:v_pricecur;
      select sum(pricerub*quantity)/sum(quantity),
             sum(pricecur*quantity)/sum(quantity)
        from cut_docspec
        where id_dochead=:v_basedoc and
              (articul=:v_articul1 or articul=:v_articul2)
      into :v_basepricerub,:v_basepricecur;
      if (v_pricerub<>v_basepricerub or v_pricecur<>v_basepricecur) then begin
        select docindex from cut_dochead where id_dochead=:v_doc into :v_docindex;
        select docindex from cut_dochead where id_dochead=:v_basedoc into :v_basedocindex;
        errcode = 2;
        errmsg = '        : '||
                 v_docindex||' rub='||v_pricerub||' cur='||v_pricecur||'   '||
                 v_basedocindex||' rub='||v_basepricerub||' cur='||v_basepricecur;
        suspend; exit;
      end
    end
  end

  /*      ( ) */
  if ((exists (select 1 from cardcompl_header where articul=:v_articul1 or articul=:v_articul2)) or
      (exists (select 1 from cardcompl where subarticul=:v_articul1 or subarticul=:v_articul2))) then begin
    errcode = 6;
    errmsg = '        ';
    suspend; exit;
  end

  /*      (  )
         
  if (exists (select 1 from cut_list)) then begin
    if (exists (select 1 from cut_docspec where articul=:V_ARTICUL1 or articul=:V_ARTICUL2 )) then begin
      errcode = 7;
      errmsg = '        ';
      suspend; exit;
    end
  end */

  /*            ( ) */
  if (exists (select 1 from cut_list)) then begin
    for select ds2.id_dochead
          from cut_docspec ds2
            left join cut_docspec ds1 on ds2.id_dochead=ds1.id_dochead and ds1.articul=:v_articul1
          where ds2.articul=:v_articul2 and ds2.dockind in (0,1)
            and ds1.id_dochead is not null and ds2.need_pay<>ds1.need_pay
          into :v_dochead do begin
      select docindex from cut_dochead where id_dochead=:v_dochead into :v_docindex;
      errcode=7;
      errmsg='   '||v_docindex||'    ';
      suspend; exit;
    end
  end

  --      ( ,    )
  if (exists(select 1 from CONFIG where paramname = 'UseRzScale' and boolparam = 'T')) then begin
    if (exists(select 1 from CARDSCLA cs1, CARDSCLA cs2
                 where cs1.articul = :v_articul1 and cs2.articul = :v_articul2 and
                       coalesce(cs1.rzscale, -1) <> coalesce(cs2.rzscale, -1))) then begin
      errcode = 8;
      errmsg = '    ';
      suspend; exit;
     end
  end

  --      ( ,      )
  if (exists(select 1 from CONFIG where paramname = 'UseTovar' and boolparam = 'T')) then begin
    if (exists(select 1 from CARDSCLA cs1, CARDSCLA cs2
                 where cs1.articul = :v_articul1 and cs2.articul = :v_articul2 and
                       coalesce(cs1.tovar, -1) <> coalesce(cs2.tovar, -1))) then begin
      errcode = 9;
      errmsg = '    ';
      suspend; exit;
    end
  end

  errcode = 0;
  errmsg = '  ';
  suspend;
end^

create or alter procedure PRN_MARKACT (
    V_SESSION char(10),
    V_OWNERCLIENT char(10))
returns (
    ID_DOCHEAD integer,
    DOCINDEX varchar(10),
    DOC_DATE date,
    ACTION_NAME varchar(255),
    BEGIN_DATE date,
    END_DATE date,
    FROM_CLIENT_NAME varchar(80),
    FILIAL integer,
    FILIAL_NAME varchar(40),
    CLIENT integer,
    CLIENT_NAME varchar(80),
    ARTICUL varchar(30),
    NAME varchar(80),
    PACK_NAME varchar(40),
    QUANTITY double precision,
    SALE_PRICE double precision,
    FACT_PRICE double precision,
    FACT_PROC double precision)
AS
declare variable v_pack integer;
declare variable v_discount double precision;
declare variable v_head_disc double precision;
declare variable v_round integer;
declare variable v_active char(1);
declare variable v_pricekind integer;
begin
  v_ownerclient=v_ownerclient;
  select name_clients from CLIENTS where id_clients=:v_ownerclient into :from_client_name;
  for select dochead
      from SELDOC
      where session=:v_session
      into :id_dochead
  do begin
    select docindex, doc_date, client_index, dochead_filialindex, prolon
      from DOCHEAD
      where id_dochead=:id_dochead
      into :docindex, :doc_date, :client, :filial, :v_active;
    select name, begin_date, end_date, disc, round_rub
      from DOCHEAD_MARKACT
      where dochead=:id_dochead
      into :action_name, :begin_date, :end_date, :v_head_disc, :v_round;
    select name_clients from CLIENTS  where id_clients=:client into :client_name;
    select name from TH_CLASSIF where id_th_classif=:filial into :filial_name;
    select pricekind from PRICE_SERVICE
      where filialindex = :filial and kind = 0 into :v_pricekind; --    

    for select articul, quantity, pricerub, spercent, mesuriment
        from DOCSPEC
        where id_dochead=:id_dochead
        into :articul, :quantity, :fact_price, :v_discount, :v_pack
    do begin
      sale_price=null;
      select old_pricerub from DOCSPEC_MARKACT
        where dochead=:id_dochead and articul=:articul into :sale_price;
      if (sale_price is null or v_active = 'F' or sale_price = 0) then begin
        --           
        --   = 0 -            
        select price_rub from GET_PRICE2(:articul, :v_pricekind) into :sale_price;
      end
      --    
      if (v_head_disc<1e-8) then begin
        if (v_discount=0) then begin
          --    ,     
          if (sale_price>1e-8) then fact_proc=(sale_price-fact_price)/sale_price*100; else fact_proc=null;
        end else begin
          --    %,      
          if (sale_price>1e-8) then fact_proc=v_discount; else fact_proc=null;
        end
      end else begin
        fact_proc=v_head_disc;
      end
      select r_value from ROUND_TO_NUM((100-:fact_proc)*:sale_price/100,:v_round) into :fact_price;

      select name from CARDSCLA where articul=:articul into :name;
      select name_mesuriment from MESURIMENT where id_mesuriment=:v_pack into :pack_name;
      suspend;
    end
  end
end^

SET TERM ; ^

COMMIT WORK;
